# -*- coding: utf-8 -*-
# Generated by Django 1.9.9 on 2016-08-08 21:16

from django.db import migrations

forward = """
    ALTER TABLE catmaid_transaction_info
    ADD COLUMN project_id integer;

    -- The project ID is used frequently to filter projects, it should therefore
    -- have an index
    CREATE INDEX catmaid_transaction_info_project_idx
    ON catmaid_transaction_info (project_id);

    -- Also create a timestamp index for recent transaction lookup
    CREATE INDEX catmaid_transaction_info_execution_time_idx
    ON catmaid_transaction_info (execution_time DESC NULLS LAST);
"""

backward = """
    DROP INDEX catmaid_transaction_info_project_idx;
    DROP INDEX catmaid_transaction_info_execution_time_idx;
    ALTER TABLE catmaid_transaction_info
    DROP COLUMN project_id;
"""

class Migration(migrations.Migration):

    dependencies = [
        ('catmaid', '0007_use_django_1_9_jsonfield'),
    ]

    operations = [
            migrations.RunSQL(forward, backward)
    ]
