# -*- coding: utf-8 -*-
# Generated by Django 1.9.13 on 2017-04-16 23:06

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('catmaid', '0021_recreate_history_view_after_auth_user_update'),
    ]

    operations = [
        migrations.CreateModel(
            name='Sampler',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creation_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('edition_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('interval_length', models.FloatField()),
                ('review_required', models.BooleanField(default=True)),
                ('project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Project')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SamplerConnectorState',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('description', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='SamplerDomain',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creation_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('edition_time', models.DateTimeField(default=django.utils.timezone.now)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SamplerDomainEnd',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('domain', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerDomain')),
                ('end_node', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Treenode')),
            ],
        ),
        migrations.CreateModel(
            name='SamplerDomainType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('description', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='SamplerInterval',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creation_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('edition_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('domain', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerDomain')),
                ('end_node', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='sampler_interval_end_node_set', to='catmaid.Treenode')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SamplerIntervalState',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('description', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='SamplerState',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('description', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='SamplerConnector',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('creation_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('edition_time', models.DateTimeField(default=django.utils.timezone.now)),
                ('connector', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Connector')),
                ('connector_state', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerConnectorState')),
                ('interval', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerInterval')),
                ('project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Project')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='samplerinterval',
            name='interval_state',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerIntervalState'),
        ),
        migrations.AddField(
            model_name='samplerinterval',
            name='project',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Project'),
        ),
        migrations.AddField(
            model_name='samplerinterval',
            name='start_node',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='sampler_interval_start_node_set', to='catmaid.Treenode'),
        ),
        migrations.AddField(
            model_name='samplerinterval',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='samplerdomain',
            name='domain_type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerDomainType'),
        ),
        migrations.AddField(
            model_name='samplerdomain',
            name='parent_interval',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerInterval'),
        ),
        migrations.AddField(
            model_name='samplerdomain',
            name='project',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Project'),
        ),
        migrations.AddField(
            model_name='samplerdomain',
            name='sampler',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Sampler'),
        ),
        migrations.AddField(
            model_name='samplerdomain',
            name='start_node',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.Treenode'),
        ),
        migrations.AddField(
            model_name='samplerdomain',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='sampler',
            name='sampler_state',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.SamplerState'),
        ),
        migrations.AddField(
            model_name='sampler',
            name='skeleton',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='catmaid.ClassInstance'),
        ),
        migrations.AddField(
            model_name='sampler',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        # Add history tables for sampler relations
        migrations.RunSQL("""
            SELECT create_history_table('catmaid_sampler'::regclass);
            SELECT create_history_table('catmaid_samplerdomain'::regclass);
            SELECT create_history_table('catmaid_samplerdomainend'::regclass);
            SELECT create_history_table('catmaid_samplerdomaintype'::regclass);
            SELECT create_history_table('catmaid_samplerinterval'::regclass);
            SELECT create_history_table('catmaid_samplerintervalstate'::regclass);
            SELECT create_history_table('catmaid_samplerstate'::regclass);
            SELECT create_history_table('catmaid_samplerconnector'::regclass);
            SELECT create_history_table('catmaid_samplerconnectorstate'::regclass);
        """, """
            SELECT disable_history_tracking_for_table('catmaid_sampler'::regclass,
                    get_history_table_name('catmaid_sampler'::regclass));
            SELECT drop_history_table('catmaid_sampler'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerdomain'::regclass,
                    get_history_table_name('catmaid_samplerdomain'::regclass));
            SELECT drop_history_table('catmaid_samplerdomain'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerdomainend'::regclass,
                    get_history_table_name('catmaid_samplerdomainend'::regclass));
            SELECT drop_history_table('catmaid_samplerdomainend'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerdomaintype'::regclass,
                    get_history_table_name('catmaid_samplerdomaintype'::regclass));
            SELECT drop_history_table('catmaid_samplerdomaintype'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerinterval'::regclass,
                    get_history_table_name('catmaid_samplerinterval'::regclass));
            SELECT drop_history_table('catmaid_samplerinterval'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerintervalstate'::regclass,
                    get_history_table_name('catmaid_samplerintervalstate'::regclass));
            SELECT drop_history_table('catmaid_samplerintervalstate'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerstate'::regclass,
                    get_history_table_name('catmaid_samplerstate'::regclass));
            SELECT drop_history_table('catmaid_samplerstate'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerconnector'::regclass,
                    get_history_table_name('catmaid_samplerconnector'::regclass));
            SELECT drop_history_table('catmaid_samplerconnector'::regclass);

            SELECT disable_history_tracking_for_table('catmaid_samplerconnectorstate'::regclass,
                    get_history_table_name('catmaid_samplerconnectorstate'::regclass));
            SELECT drop_history_table('catmaid_samplerconnectorstate'::regclass);
        """)
    ]
