# -*- coding: utf-8 -*-
# Generated by Django 1.10.7 on 2017-07-19 14:36

from django.db import migrations, models

forward = """
    CREATE INDEX treenode__history_skeleton_id_index ON treenode__history (skeleton_id);
    CREATE INDEX treenode_connector__history_skeleton_id_index ON treenode_connector__history (skeleton_id);
    CREATE INDEX review__history_skeleton_id_index ON review__history (skeleton_id);
    CREATE INDEX class_instance_class_instance__history_class_instance_a_index ON class_instance_class_instance__history (class_instance_a);
    CREATE INDEX class_instance_class_instance__history_class_instance_b_index ON class_instance_class_instance__history (class_instance_b);
    CREATE INDEX treenode_class_instance__history_relation_id_index ON treenode_class_instance__history (relation_id);
    CREATE INDEX treenode_class_instance__history_treenode_id_index ON treenode_class_instance__history (treenode_id );
"""

backward = """
    DROP INDEX treenode__history_skeleton_id_index;
    DROP INDEX treenode_connector__history_skeleton_id_index;
    DROP INDEX review__history_skeleton_id_index;
    DROP INDEX class_instance_class_instance__history_class_instance_a_index;
    DROP INDEX class_instance_class_instance__history_class_instance_b_index;
    DROP INDEX treenode_class_instance__history_relation_id_index;
    DROP INDEX treenode_class_instance__history_treenode_id_index;
"""

class Migration(migrations.Migration):
    """Add indices tnhat improve the performance of some history queries, for
    instance in the Neuron History Widget or when retrieving historic skeleton
    data for animation.
    """

    dependencies = [
        ('catmaid', '0023_update_edit_txids'),
    ]

    operations = [
        migrations.RunSQL(forward, backward)
    ]
