# -*- coding: utf-8 -*-
# Generated by Django 1.10.7 on 2017-07-19 14:36

from django.db import migrations, models

forward = """
    CREATE INDEX treenode__history_creation_time_id_index
        ON treenode__history (creation_time);
    CREATE INDEX catmaid_transaction_info_project_id_label_idx
        ON catmaid_transaction_info (project_id, label);
"""

backward = """
    DROP INDEX treenode__history_creation_time_id_index;
    DROP INDEX catmaid_transaction_info_project_id_label_idx;
"""

class Migration(migrations.Migration):
    """Add indices that have a postive effect on performance of import filtering
    related statistics queries.
    """

    dependencies = [
        ('catmaid', '0025_add_stats_summary_table'),
    ]

    operations = [
        migrations.RunSQL(forward, backward)
    ]
