# -*- coding: utf-8 -*-
# Generated by Django 1.11.8 on 2018-01-12 03:48

from django.db import migrations


forward = """
    CREATE TABLE node_query_cache (
        project_id integer REFERENCES project (id),
        orientation integer DEFAULT 0 NOT NULL,
        depth real NOT NULL,
        json_data jsonb,
        json_text_data text,
        msgpack_data bytea
    );

    CREATE INDEX node_query_cache_project_orientation_z_idx ON node_query_cache (project_id, orientation, depth);
"""

backward = """
    DROP TABLE node_query_cache;
"""

class Migration(migrations.Migration):
    """Add the node_query_cache table, which is used to query whole sections
    for individual orientations in particular projects. This can help to provide
    quicker overviews on larger fields of view.
    """

    dependencies = [
        ('catmaid', '0031_add_interpolatable_sections_table'),
    ]

    operations = [
        migrations.RunSQL(forward, backward)
    ]
