# Generated by Django 2.1.5 on 2019-02-14 03:02

import django.contrib.postgres.fields
from django.db import migrations, models


forward = """
    SELECT disable_history_tracking_for_table('nblast_similarity'::regclass,
            get_history_table_name('nblast_similarity'::regclass));
    SELECT drop_history_view_for_table('nblast_similarity'::regclass);

    ALTER TABLE nblast_similarity
    ADD COLUMN computation_time real;

    ALTER TABLE nblast_similarity__history
    ADD COLUMN computation_time real;

    ALTER TABLE nblast_similarity
    ADD COLUMN detailed_status text;

    ALTER TABLE nblast_similarity__history
    ADD COLUMN detailed_status text;

    ALTER TABLE nblast_similarity
    ADD COLUMN invalid_query_objects bigint[];

    ALTER TABLE nblast_similarity__history
    ADD COLUMN invalid_query_objects bigint[];

    ALTER TABLE nblast_similarity
    ADD COLUMN invalid_target_objects bigint[];

    ALTER TABLE nblast_similarity__history
    ADD COLUMN invalid_target_objects bigint[];

    SELECT create_history_view_for_table('nblast_similarity'::regclass);
    SELECT enable_history_tracking_for_table('nblast_similarity'::regclass,
            get_history_table_name('nblast_similarity'::regclass), FALSE);
"""

backward = """
    SELECT disable_history_tracking_for_table('nblast_similarity'::regclass,
            get_history_table_name('nblast_similarity'::regclass));
    SELECT drop_history_view_for_table('nblast_similarity'::regclass);

    ALTER TABLE nblast_similarity
    DROP COLUMN computation_time;

    ALTER TABLE nblast_similarity__history
    DROP COLUMN computation_time;

    ALTER TABLE nblast_similarity
    DROP COLUMN detailed_status;

    ALTER TABLE nblast_similarity__history
    DROP COLUMN detailed_status;

    ALTER TABLE nblast_similarity
    DROP COLUMN invalid_query_objects;

    ALTER TABLE nblast_similarity__history
    DROP COLUMN invalid_query_objects;

    ALTER TABLE nblast_similarity
    DROP COLUMN invalid_target_objects;

    ALTER TABLE nblast_similarity__history
    DROP COLUMN invalid_target_objects;

    SELECT create_history_view_for_table('nblast_similarity'::regclass);
    SELECT enable_history_tracking_for_table('nblast_similarity'::regclass,
            get_history_table_name('nblast_similarity'::regclass), FALSE);
"""


class Migration(migrations.Migration):

    dependencies = [
        ('catmaid', '0062_update_stack_metadata_comment_and_stackmirror_choices'),
    ]

    operations = [
        migrations.RunSQL(forward, backward, [
            migrations.AddField(
                model_name='nblastsimilarity',
                name='computation_time',
                field=models.FloatField(default=0),
            ),
            migrations.AddField(
                model_name='nblastsimilarity',
                name='detailed_status',
                field=models.TextField(blank=True, null=True),
            ),
            migrations.AddField(
                model_name='nblastsimilarity',
                name='invalid_query_objects',
                field=django.contrib.postgres.fields.ArrayField(base_field=models.IntegerField(), blank=True, default=None, null=True, size=None),
            ),
            migrations.AddField(
                model_name='nblastsimilarity',
                name='invalid_target_objects',
                field=django.contrib.postgres.fields.ArrayField(base_field=models.IntegerField(), blank=True, default=None, null=True, size=None),
            ),
        ]),
    ]
