# -*- coding: utf-8 -*-
# Generated by Django 1.9.9 on 2016-08-07 21:58

import django.contrib.postgres.fields.jsonb
from django.db import migrations


# DDL triggers aren't yet implemented for CATMAID's history tracking. Therefore,
# the history updates have to be implemented manually. Additionally, there is no
# need to create a new history table column for this type conversion and an
# in-place type update is appropriate.

update_clientdata_history = """
    DO $$
    BEGIN
    EXECUTE format(
        'ALTER TABLE %1$s '
        'ALTER COLUMN data '
        'TYPE jsonb '
        'USING data::jsonb',
        history_table_name('performancetests_testview'::regclass));
    END
    $$;
"""

downgrade_clientdata_history = """
    DO $$
    BEGIN
    EXECUTE format(
        'ALTER TABLE %1$s '
        'ALTER COLUMN data '
        'TYPE text '
        'USING data::text',
        history_table_name('performancetests_testview'::regclass));
    END
    $$;
"""


class Migration(migrations.Migration):

    dependencies = [
        ('performancetests', '0001_initial'),
    ]

    operations = [
        migrations.AlterField(
            model_name='testview',
            name='data',
            field=django.contrib.postgres.fields.jsonb.JSONField(blank=True, default={}),
        ),
    ]
